--[[
    GuildMailboxForm
  ]]--

------------------------------------------------------------------------------------
--
-- Initialize drop down menus
--
------------------------------------------------------------------------------------

--RankTypeDrop
function GuildMailboxFormRankTypeDrop_OnLoad(self)
	UIDropDownMenu_Initialize(self, GuildMailboxFormRankTypeDrop_LoadTypes)
	UIDropDownMenu_SetSelectedValue(self, 0)
end

function GuildMailboxFormRankTypeDrop_LoadTypes()	
	UIDropDownMenu_AddButton({value = 0 , text = "is a",       func = GuildMailboxFormRankTypeDrop_OnClick})
	UIDropDownMenu_AddButton({value = 1 , text = "is not a",   func = GuildMailboxFormRankTypeDrop_OnClick})
	UIDropDownMenu_AddButton({value = 2 , text = "is at least a", func = GuildMailboxFormRankTypeDrop_OnClick})
	UIDropDownMenu_AddButton({value = 3 , text = "is at most a",  func = GuildMailboxFormRankTypeDrop_OnClick})
end	

function GuildMailboxFormRankTypeDrop_OnClick(self)
	UIDropDownMenu_SetSelectedValue(GuildMailboxFormRankTypeDrop, self.value)
	GuildMailboxForm_UpdateCosts()
end

-- RankDrop
function GuildMailboxFormRankDrop_OnLoad(self)
	UIDropDownMenu_Initialize(self, GuildMailboxFormRankDrop_LoadRanks)
	UIDropDownMenu_SetSelectedValue(self, 0)
end

function GuildMailboxFormRankDrop_LoadRanks()
	UIDropDownMenu_AddButton({value = 0 , text = "All", func = GuildMailboxFormRankDrop_OnClick})
	for i=1,GuildControlGetNumRanks() do
		UIDropDownMenu_AddButton({value = i , text = GuildControlGetRankName(i) , func = GuildMailboxFormRankDrop_OnClick})
	end;
end	

function GuildMailboxFormRankDrop_OnClick(self)
	UIDropDownMenu_SetSelectedValue(GuildMailboxFormRankDrop, self.value)
	GuildMailboxForm_UpdateCosts()
end

--ClassTypeDrop
function GuildMailboxFormClassTypeDrop_OnLoad(self)
	UIDropDownMenu_Initialize(self, GuildMailboxFormClassTypeDrop_LoadTypes)
	UIDropDownMenu_SetSelectedValue(self, 0)
end

function GuildMailboxFormClassTypeDrop_LoadTypes()
	UIDropDownMenu_AddButton({value = 0 , text = "is a",       func = GuildMailboxFormClassTypeDrop_OnClick})
	UIDropDownMenu_AddButton({value = 1 , text = "is not a",   func = GuildMailboxFormClassTypeDrop_OnClick})
end	

function GuildMailboxFormClassTypeDrop_OnClick(self)
	UIDropDownMenu_SetSelectedValue(GuildMailboxFormClassTypeDrop, self.value)
	GuildMailboxForm_UpdateCosts()
end

-- ClassDrop
function GuildMailboxFormClassDrop_OnLoad(self)
	UIDropDownMenu_Initialize(self, GuildMailboxFormClassDrop_LoadClasses)
	UIDropDownMenu_SetSelectedValue(self, 0)
end

function GuildMailboxFormClassDrop_LoadClasses()
	UIDropDownMenu_AddButton({value = 0 , text = "All",    func = GuildMailboxFormClassDrop_OnClick})

      UIDropDownMenu_AddButton({value = "Death Knight"  , text = "Death Knight",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Druid"   , text = "Druid",  func = GuildMailboxFormClassDrop_OnClick})

      UIDropDownMenu_AddButton({value = "Hunter"  , text = "Hunter",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Mage"    , text = "Mage",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Monk"    , text = "Monk",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Paladin" , text = "Paladin",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Priest"  , text = "Priest",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Rogue"   , text = "Rogue",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Shaman"  , text = "Shaman",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Warlock" , text = "Warlock",  func = GuildMailboxFormClassDrop_OnClick})

	UIDropDownMenu_AddButton({value = "Warrior" , text = "Warrior", func = GuildMailboxFormClassDrop_OnClick})

end	

function GuildMailboxFormClassDrop_OnClick(self)
	UIDropDownMenu_SetSelectedValue(GuildMailboxFormClassDrop, self.value)
	GuildMailboxForm_UpdateCosts()
end

--NoteTypeDrop
function GuildMailboxFormNoteTypeDrop_OnLoad(self)
	UIDropDownMenu_Initialize(self, GuildMailboxFormNoteTypeDrop_LoadTypes)
	UIDropDownMenu_SetSelectedValue(self, 0)
end

function GuildMailboxFormNoteTypeDrop_LoadTypes()
	UIDropDownMenu_AddButton({value = 0 , text = "contains",       func = GuildMailboxFormNoteTypeDrop_OnClick})
	UIDropDownMenu_AddButton({value = 1 , text = "does not contain",   func = GuildMailboxFormNoteTypeDrop_OnClick})
end	

function GuildMailboxFormNoteTypeDrop_OnClick(self)
	UIDropDownMenu_SetSelectedValue(GuildMailboxFormNoteTypeDrop, self.value)
	GuildMailboxForm_UpdateCosts()
end

-----------------------------------------------------------------------------------
--
-- Updates number of mails and cost display
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_UpdateCosts()
	local list = GuildMailboxForm_GetFilteredGuildMembers()
	local cost = table.getn(list) * GetSendMailPrice()
      GuildMailboxFormCostLabel:SetText(string.format("%s mails cost:", table.getn(list)))
      MoneyFrame_Update("GuildMailboxFormCost", cost)
end
-----------------------------------------------------------------------------------
--
-- This function returns cost for sending mail to count people as string
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_GetCostString(count)
	local copperCost = count * GetSendMailPrice()
	local goldCost = math.floor(copperCost/COPPER_PER_GOLD)
	copperCost = copperCost - goldCost*COPPER_PER_GOLD
	local silverCost = math.floor(copperCost/COPPER_PER_SILVER)
	copperCost = copperCost - silverCost*COPPER_PER_SILVER
	
	return string.format("%dG %dS %dC", goldCost, silverCost, copperCost)
end

-----------------------------------------------------------------------------------
--
-- This function is called if the send button is pressed
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_Send()
	local subject = SendMailSubjectEditBox:GetText()
	local body = SendMailBodyEditBox:GetText()
	local copper = MoneyInputFrame_GetCopper(SendMailMoney);
	
	local guildMembers = GuildMailboxForm_GetFilteredGuildMembers()
	
	for i=1,table.getn(guildMembers) do	
         Queue_push(GUILDMAILBOX_MAILQUEUE, {guildMembers[i], subject, body, copper})	
	end
		
	local count = table.getn(guildMembers)
	local message = string.format("Sending mail '%s' to %d people. Cost: %s", subject, count, GuildMailboxForm_GetCostString(count)) 
	Print(message)
		
	readyToSendNextMessage = true
	
	SendMailFrame_CanSend()
	GuildMailboxForm:Hide()
end

-----------------------------------------------------------------------------------
--
-- This function is called if the cancel button is pressed
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_Cancel()
	SendMailFrame_CanSend()
	GuildMailboxForm:Hide()
end

-----------------------------------------------------------------------------------
--
-- Filter rank
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_testRank(rankIndex) 
	local rankType = UIDropDownMenu_GetSelectedValue(GuildMailboxFormRankTypeDrop)
	local rankIndexFilter = UIDropDownMenu_GetSelectedValue(GuildMailboxFormRankDrop) - 1
	if (rankIndexFilter == -1) then
		return true
	else
		if (rankType == 0) then -- IS
			return (rankIndex == rankIndexFilter)
		elseif (rankType == 1) then -- IS NOT
			return (rankIndex ~= rankIndexFilter)
		elseif (rankType == 2) then -- AT LEAST
			return (rankIndex <= rankIndexFilter) -- indexes are the wrong way around (0 = guildmaster ...)
		elseif (rankType == 3) then -- AT MOST
			return (rankIndex >= rankIndexFilter)
		end
	end
	
	Print("GuildMailbox internal BUG!")
	return false
end

-----------------------------------------------------------------------------------
--
-- Filter note
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_testNote(note) 
	local noteType = UIDropDownMenu_GetSelectedValue(GuildMailboxFormNoteTypeDrop)
	local noteFilter = GuildMailboxFormNoteEdit:GetText()
	if (string.len(noteFilter) == 0) then
		return true
	else
		if (noteType == 0) then -- CONTAINS
			return string.find(note, noteFilter, 1, true)		
		elseif (noteType == 1) then -- CONTAINS NOT
			return not string.find(note, noteFilter, 1, true)
		end
	end
	
	Print("GuildMailbox internal BUG!")
	return false
end

-----------------------------------------------------------------------------------
--
-- Filter class
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_testClass(class)
	local classType = UIDropDownMenu_GetSelectedValue(GuildMailboxFormClassTypeDrop)
	local classFilter = UIDropDownMenu_GetSelectedValue(GuildMailboxFormClassDrop)
	if (classFilter == 0) then
		return true
	else 
		if (classType == 0) then -- IS
			return string.find(class, classFilter, 1, true)
		elseif (classType == 1) then -- IS NOT
			return not string.find(class, classFilter, 1, true)
		end
	end
	
	Print("GuildMailbox internal BUG!")
	return false
end

-----------------------------------------------------------------------------------
--
-- Filter level
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_testLevel(level) 
	local levelFrom = tonumber(GuildMailboxFormLevelFromEdit:GetText())
	local levelTo = tonumber(GuildMailboxFormLevelToEdit:GetText())
	
	if (levelFrom == nil) then
		levelFrom = 1
	end
	
	if (levelTo == nil) then
		levelTo = 90 
	end
	
	return ((levelFrom == 1) or (level >= levelFrom)) and ((levelTo == 90) or (level <= levelTo))
end

-----------------------------------------------------------------------------------
--
-- This function returns a list of guildmembers, who want to/should get mail
--
-----------------------------------------------------------------------------------
function GuildMailboxForm_GetFilteredGuildMembers()
	local count = GetNumGuildMembers(true) -- get offline guild members too
	local list = {}
	
	for i=1, count, 1 do
		local name, rank, rankIndex, level, class, zone, note, officernote, online = GetGuildRosterInfo(i);
           local sa, sb = strsplit("-", name)
	
		if ( UnitName("player") ~= sa
			and GuildMailboxForm_testRank(rankIndex)
			and GuildMailboxForm_testClass(class)
			and GuildMailboxForm_testNote(note)
			and GuildMailboxForm_testLevel(level)) then
				Debug("name: " .. name .. " rank: " .. rankIndex .. " class: " .. class .. " note: " .. note .. " level: " .. level)
				table.insert(list, name)
		end		
	end
   
	table.sort(list)

	return list
end